import { AxiosRequestConfig } from 'axios';
import { ErrorState, ErrorType } from '../services/requests';
declare type UseAxios<T> = [
    response: T | null,
    loading: boolean,
    call: (config?: AxiosRequestConfig) => Promise<void>,
    clean: () => void,
    status: number | undefined,
    error: ErrorType | undefined
];
export declare type AxiosConfig = Omit<AxiosRequestConfig, 'url'>;
interface Props {
    onInit?: AxiosConfig | boolean;
    onError?: (error: ErrorState) => void;
}
export declare const useAxios: <T extends unknown>(url: string, config?: Props | undefined, noSerialize?: true | undefined) => UseAxios<T>;
export {};
