import React, { Dispatch, PropsWithChildren, SetStateAction } from 'react';
import { ErrorState } from '../services/requests';
import { HeadersType } from './AxiosProvider';
export declare type UserType<T> = T | null;
declare type ContextType<T> = [UserType<T>, Dispatch<SetStateAction<UserType<T>>>];
export declare const UserContext: React.Context<ContextType<any>>;
export declare const useUserContext: <T>() => ContextType<T>;
export declare type ProviderPros<T> = PropsWithChildren<{
    headers?: HeadersType;
    user: UserType<T>;
    onUser: (user: UserType<T>) => void;
    onAxiosError?: (error: ErrorState) => void;
}>;
export declare const UserAxiosProvider: <T>(props: ProviderPros<T>) => JSX.Element;
export {};
