import React, { Dispatch, PropsWithChildren, SetStateAction } from 'react';
export declare type UserType<T> = T | null;
declare type ContextType<T> = [UserType<T>, Dispatch<SetStateAction<UserType<T>>>];
export declare const UserContext: React.Context<ContextType<any>>;
export declare const useUserContext: <T>() => ContextType<T>;
declare type ProviderPros<T> = PropsWithChildren<{
    urls: Record<string, unknown>;
    user: UserType<T>;
    onUser: (user: UserType<T>) => void;
}>;
export declare const UserAxiosProvider: <T>(props: ProviderPros<T>) => JSX.Element;
export {};
