import { ErrorType } from './requests';
export interface ReducerState<T> {
    data: T | null;
    loading?: boolean;
    error?: ErrorType;
    status?: number;
}
export declare type ReducerAction<T> = {
    type: 'FETCH';
    key: string;
} | {
    type: 'FINISH';
    key: string;
    data: T | null;
    status: number;
} | {
    type: 'ERROR';
    key: string;
    error: ErrorType;
} | {
    type: 'CLEAN';
    key: string;
};
export declare const initialState: {
    data: null;
};
declare const axiosReducer: <T extends unknown>(state: ReducerState<T>, action: ReducerAction<T>) => ReducerState<T>;
export default axiosReducer;
