import { AxiosRequestConfig } from 'axios';
export declare type ErrorState = {
    message: string;
    code: number;
};
export declare type ErrorType = {
    error: ErrorState;
    type: 'single';
} | {
    errors: ErrorState[];
    type: 'multiple';
};
interface RequestReturn<T extends unknown> {
    data?: T;
    status?: number;
    error?: ErrorType;
}
export declare const makeRequest: <T extends unknown>(config: AxiosRequestConfig, noSerialize?: true | undefined) => Promise<RequestReturn<T>>;
export {};
